<html>
<head>
<title>OGRE: OgreVector2.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreVector2.h</h1><a href="OgreVector2_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Vector2_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Vector2_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreMath_8h.html">OgreMath.h</a>"</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00046"></a><a class="code" href="classOgre_1_1Vector2.html">00046</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>
<a name="l00047"></a>00047     {
<a name="l00048"></a>00048     <span class="keyword">public</span>:
<a name="l00049"></a><a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">00049</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, y;
<a name="l00050"></a>00050 
<a name="l00051"></a>00051     <span class="keyword">public</span>:
<a name="l00052"></a><a class="code" href="classOgre_1_1Vector2.html#54198b2714496715f6f9ec24c1194cad">00052</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>()
<a name="l00053"></a>00053         {
<a name="l00054"></a>00054         }
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="classOgre_1_1Vector2.html#157950d8cbe0e44a2271479a4f8bcdab">00056</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fX, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fY )
<a name="l00057"></a>00057             : x( fX ), y( fY )
<a name="l00058"></a>00058         {
<a name="l00059"></a>00059         }
<a name="l00060"></a>00060 
<a name="l00061"></a><a class="code" href="classOgre_1_1Vector2.html#1c2a513e68d4e223135a5d891a569501">00061</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scaler )
<a name="l00062"></a>00062             : x( scaler), y( scaler )
<a name="l00063"></a>00063         {
<a name="l00064"></a>00064         }
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classOgre_1_1Vector2.html#6f05ab5b82a5dd3f191e388d4a734614">00066</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> afCoordinate[2] )
<a name="l00067"></a>00067             : x( afCoordinate[0] ),
<a name="l00068"></a>00068               y( afCoordinate[1] )
<a name="l00069"></a>00069         {
<a name="l00070"></a>00070         }
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="classOgre_1_1Vector2.html#c04fe07fceec444e2a13b0195bcb2c64">00072</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>( <span class="keyword">const</span> <span class="keywordtype">int</span> afCoordinate[2] )
<a name="l00073"></a>00073         {
<a name="l00074"></a>00074             x = (<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[0];
<a name="l00075"></a>00075             y = (<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[1];
<a name="l00076"></a>00076         }
<a name="l00077"></a>00077 
<a name="l00078"></a><a class="code" href="classOgre_1_1Vector2.html#df501af1ce3df540dee7953ddb32cb51">00078</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>( <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* <span class="keyword">const</span> r )
<a name="l00079"></a>00079             : x( r[0] ), y( r[1] )
<a name="l00080"></a>00080         {
<a name="l00081"></a>00081         }
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classOgre_1_1Vector2.html#3578c5fd9c51469fff590dc15f62abf8">00083</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )
<a name="l00084"></a>00084             : x( rkVector.x ), y( rkVector.y )
<a name="l00085"></a>00085         {
<a name="l00086"></a>00086         }
<a name="l00087"></a>00087 
<a name="l00088"></a><a class="code" href="classOgre_1_1Vector2.html#71b01bfe42118ef067e14e1092e7773f">00088</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )<span class="keyword"> const</span>
<a name="l00089"></a>00089 <span class="keyword">        </span>{
<a name="l00090"></a>00090             assert( i &lt; 2 );
<a name="l00091"></a>00091 
<a name="l00092"></a>00092             <span class="keywordflow">return</span> *(&amp;x+i);
<a name="l00093"></a>00093         }
<a name="l00094"></a>00094 
<a name="l00095"></a><a class="code" href="classOgre_1_1Vector2.html#ae029eb05f9ab47565e5b47bb2ee9d91">00095</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )
<a name="l00096"></a>00096         {
<a name="l00097"></a>00097             assert( i &lt; 2 );
<a name="l00098"></a>00098 
<a name="l00099"></a>00099             <span class="keywordflow">return</span> *(&amp;x+i);
<a name="l00100"></a>00100         }
<a name="l00101"></a>00101 
<a name="l00103"></a><a class="code" href="classOgre_1_1Vector2.html#307ca54d90a1a35b54a5416810681b3a">00103</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()
<a name="l00104"></a>00104         {
<a name="l00105"></a>00105             <span class="keywordflow">return</span> &amp;x;
<a name="l00106"></a>00106         }
<a name="l00108"></a><a class="code" href="classOgre_1_1Vector2.html#d72265d712677a9d628f0231c2e7c460">00108</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()<span class="keyword"> const</span>
<a name="l00109"></a>00109 <span class="keyword">        </span>{
<a name="l00110"></a>00110             <span class="keywordflow">return</span> &amp;x;
<a name="l00111"></a>00111         }
<a name="l00112"></a>00112 
<a name="l00117"></a><a class="code" href="classOgre_1_1Vector2.html#94d813e76f805306436e19a785e75a26">00117</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator = ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )
<a name="l00118"></a>00118         {
<a name="l00119"></a>00119             x = rkVector.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a>;
<a name="l00120"></a>00120             y = rkVector.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00121"></a>00121 
<a name="l00122"></a>00122             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00123"></a>00123         }
<a name="l00124"></a>00124 
<a name="l00125"></a><a class="code" href="classOgre_1_1Vector2.html#057b23bf29fadca9f2a4f0ff19a9bf61">00125</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator = ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar)
<a name="l00126"></a>00126         {
<a name="l00127"></a>00127             x = fScalar;
<a name="l00128"></a>00128             y = fScalar;
<a name="l00129"></a>00129 
<a name="l00130"></a>00130             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00131"></a>00131         }
<a name="l00132"></a>00132 
<a name="l00133"></a><a class="code" href="classOgre_1_1Vector2.html#4404d6cdc32ecbc7d1b4ff5bc247d68a">00133</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespaceOgre.html#b426b0250db523190d60f4bfe0414499">operator == </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00134"></a>00134 <span class="keyword">        </span>{
<a name="l00135"></a>00135             <span class="keywordflow">return</span> ( x == rkVector.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a> &amp;&amp; y == rkVector.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a> );
<a name="l00136"></a>00136         }
<a name="l00137"></a>00137 
<a name="l00138"></a><a class="code" href="classOgre_1_1Vector2.html#f8a82d880cf79a247d4eb8a70f61702f">00138</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespaceOgre.html#9d8174300d9fd7b766d727c85e11a20f">operator != </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00139"></a>00139 <span class="keyword">        </span>{
<a name="l00140"></a>00140             <span class="keywordflow">return</span> ( x != rkVector.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a> || y != rkVector.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>  );
<a name="l00141"></a>00141         }
<a name="l00142"></a>00142 
<a name="l00143"></a>00143         <span class="comment">// arithmetic operations</span>
<a name="l00144"></a><a class="code" href="classOgre_1_1Vector2.html#806a988c00ef4351b8e6d534bd0f09b6">00144</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> operator + ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00145"></a>00145 <span class="keyword">        </span>{
<a name="l00146"></a>00146             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00147"></a>00147                 x + rkVector.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a>,
<a name="l00148"></a>00148                 y + rkVector.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00149"></a>00149         }
<a name="l00150"></a>00150 
<a name="l00151"></a><a class="code" href="classOgre_1_1Vector2.html#b00bb30f312804b9eeedb8c8816da88b">00151</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> operator - ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00152"></a>00152 <span class="keyword">        </span>{
<a name="l00153"></a>00153             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00154"></a>00154                 x - rkVector.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a>,
<a name="l00155"></a>00155                 y - rkVector.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00156"></a>00156         }
<a name="l00157"></a>00157 
<a name="l00158"></a><a class="code" href="classOgre_1_1Vector2.html#4fdaaf501796c450d0671d41b4dafbe5">00158</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="namespaceOgre.html#8c1aea4f2e6336301a39efede7ef553b">operator * </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )<span class="keyword"> const</span>
<a name="l00159"></a>00159 <span class="keyword">        </span>{
<a name="l00160"></a>00160             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00161"></a>00161                 x * fScalar,
<a name="l00162"></a>00162                 y * fScalar);
<a name="l00163"></a>00163         }
<a name="l00164"></a>00164 
<a name="l00165"></a><a class="code" href="classOgre_1_1Vector2.html#5d47fb57acc7ae2bf36d29230b1cda1b">00165</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="namespaceOgre.html#8c1aea4f2e6336301a39efede7ef553b">operator * </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00166"></a>00166 <span class="keyword">        </span>{
<a name="l00167"></a>00167             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00168"></a>00168                 x * rhs.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a>,
<a name="l00169"></a>00169                 y * rhs.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00170"></a>00170         }
<a name="l00171"></a>00171 
<a name="l00172"></a><a class="code" href="classOgre_1_1Vector2.html#c22564f2426d1feaf991373d70ee2ba6">00172</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="namespaceOgre.html#49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )<span class="keyword"> const</span>
<a name="l00173"></a>00173 <span class="keyword">        </span>{
<a name="l00174"></a>00174             assert( fScalar != 0.0 );
<a name="l00175"></a>00175 
<a name="l00176"></a>00176             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fInv = 1.0 / fScalar;
<a name="l00177"></a>00177 
<a name="l00178"></a>00178             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00179"></a>00179                 x * fInv,
<a name="l00180"></a>00180                 y * fInv);
<a name="l00181"></a>00181         }
<a name="l00182"></a>00182 
<a name="l00183"></a><a class="code" href="classOgre_1_1Vector2.html#0832212595e63003914ab30c2020149b">00183</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="namespaceOgre.html#49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00184"></a>00184 <span class="keyword">        </span>{
<a name="l00185"></a>00185             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00186"></a>00186                 x / rhs.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a>,
<a name="l00187"></a>00187                 y / rhs.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00188"></a>00188         }
<a name="l00189"></a>00189 
<a name="l00190"></a><a class="code" href="classOgre_1_1Vector2.html#f22ae1e752951b66f3c3ef59134f1dfc">00190</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator + ()<span class="keyword"> const</span>
<a name="l00191"></a>00191 <span class="keyword">        </span>{
<a name="l00192"></a>00192             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00193"></a>00193         }
<a name="l00194"></a>00194 
<a name="l00195"></a><a class="code" href="classOgre_1_1Vector2.html#aebb1a9a4be8649241189c6ff02d170c">00195</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> operator - ()<span class="keyword"> const</span>
<a name="l00196"></a>00196 <span class="keyword">        </span>{
<a name="l00197"></a>00197             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(-x, -y);
<a name="l00198"></a>00198         }
<a name="l00199"></a>00199 
<a name="l00200"></a>00200         <span class="comment">// overloaded operators to help Vector2</span>
<a name="l00201"></a><a class="code" href="classOgre_1_1Vector2.html#7c810d71937917b48aa28409ecd2fb3f">00201</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="namespaceOgre.html#8c1aea4f2e6336301a39efede7ef553b">operator * </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )
<a name="l00202"></a>00202         {
<a name="l00203"></a>00203             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00204"></a>00204                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a>,
<a name="l00205"></a>00205                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00206"></a>00206         }
<a name="l00207"></a>00207 
<a name="l00208"></a><a class="code" href="classOgre_1_1Vector2.html#51c18bb1a1071f8078084cb968ddb5d2">00208</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="namespaceOgre.html#49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )
<a name="l00209"></a>00209         {
<a name="l00210"></a>00210             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00211"></a>00211                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a>,
<a name="l00212"></a>00212                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00213"></a>00213         }
<a name="l00214"></a>00214 
<a name="l00215"></a><a class="code" href="classOgre_1_1Vector2.html#3ffc15c2ad86866acd071c0748126fbb">00215</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> operator + (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> rhs)
<a name="l00216"></a>00216         {
<a name="l00217"></a>00217             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00218"></a>00218                 lhs.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a> + rhs,
<a name="l00219"></a>00219                 lhs.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a> + rhs);
<a name="l00220"></a>00220         }
<a name="l00221"></a>00221 
<a name="l00222"></a><a class="code" href="classOgre_1_1Vector2.html#67176f44a1c406e85fe12787373ef377">00222</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> operator + (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> lhs, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rhs)
<a name="l00223"></a>00223         {
<a name="l00224"></a>00224             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00225"></a>00225                 lhs + rhs.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a>,
<a name="l00226"></a>00226                 lhs + rhs.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00227"></a>00227         }
<a name="l00228"></a>00228 
<a name="l00229"></a><a class="code" href="classOgre_1_1Vector2.html#ed2661adf58895a08a1b38054d8d5743">00229</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> operator - (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> rhs)
<a name="l00230"></a>00230         {
<a name="l00231"></a>00231             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00232"></a>00232                 lhs.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a> - rhs,
<a name="l00233"></a>00233                 lhs.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a> - rhs);
<a name="l00234"></a>00234         }
<a name="l00235"></a>00235 
<a name="l00236"></a><a class="code" href="classOgre_1_1Vector2.html#6d976cf52f54a51f4b42ef31c3bede89">00236</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> operator - (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> lhs, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rhs)
<a name="l00237"></a>00237         {
<a name="l00238"></a>00238             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00239"></a>00239                 lhs - rhs.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a>,
<a name="l00240"></a>00240                 lhs - rhs.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00241"></a>00241         }
<a name="l00242"></a>00242         <span class="comment">// arithmetic updates</span>
<a name="l00243"></a><a class="code" href="classOgre_1_1Vector2.html#ac6485bd52d65876c6d625f0dbbf634b">00243</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator += ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )
<a name="l00244"></a>00244         {
<a name="l00245"></a>00245             x += rkVector.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a>;
<a name="l00246"></a>00246             y += rkVector.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00247"></a>00247 
<a name="l00248"></a>00248             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00249"></a>00249         }
<a name="l00250"></a>00250 
<a name="l00251"></a><a class="code" href="classOgre_1_1Vector2.html#7d85454520d16e1737be3d79b6950d39">00251</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator += ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScaler )
<a name="l00252"></a>00252         {
<a name="l00253"></a>00253             x += fScaler;
<a name="l00254"></a>00254             y += fScaler;
<a name="l00255"></a>00255 
<a name="l00256"></a>00256             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00257"></a>00257         }
<a name="l00258"></a>00258 
<a name="l00259"></a><a class="code" href="classOgre_1_1Vector2.html#a4e5a79a3880c71499ea5c6fc3709151">00259</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator -= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )
<a name="l00260"></a>00260         {
<a name="l00261"></a>00261             x -= rkVector.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a>;
<a name="l00262"></a>00262             y -= rkVector.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00263"></a>00263 
<a name="l00264"></a>00264             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00265"></a>00265         }
<a name="l00266"></a>00266 
<a name="l00267"></a><a class="code" href="classOgre_1_1Vector2.html#db77e6fdba8c5a6a55b6c53f16a2cf5f">00267</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator -= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScaler )
<a name="l00268"></a>00268         {
<a name="l00269"></a>00269             x -= fScaler;
<a name="l00270"></a>00270             y -= fScaler;
<a name="l00271"></a>00271 
<a name="l00272"></a>00272             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00273"></a>00273         }
<a name="l00274"></a>00274 
<a name="l00275"></a><a class="code" href="classOgre_1_1Vector2.html#710343631b9a695d34fa0dac9231373f">00275</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator *= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00276"></a>00276         {
<a name="l00277"></a>00277             x *= fScalar;
<a name="l00278"></a>00278             y *= fScalar;
<a name="l00279"></a>00279 
<a name="l00280"></a>00280             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00281"></a>00281         }
<a name="l00282"></a>00282 
<a name="l00283"></a><a class="code" href="classOgre_1_1Vector2.html#ee92fb485741750ff9c1de5c5d94f602">00283</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator *= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )
<a name="l00284"></a>00284         {
<a name="l00285"></a>00285             x *= rkVector.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a>;
<a name="l00286"></a>00286             y *= rkVector.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00287"></a>00287 
<a name="l00288"></a>00288             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00289"></a>00289         }
<a name="l00290"></a>00290 
<a name="l00291"></a><a class="code" href="classOgre_1_1Vector2.html#5ee66b093d0a415c57e7918523cabeaf">00291</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator /= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00292"></a>00292         {
<a name="l00293"></a>00293             assert( fScalar != 0.0 );
<a name="l00294"></a>00294 
<a name="l00295"></a>00295             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fInv = 1.0 / fScalar;
<a name="l00296"></a>00296 
<a name="l00297"></a>00297             x *= fInv;
<a name="l00298"></a>00298             y *= fInv;
<a name="l00299"></a>00299 
<a name="l00300"></a>00300             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00301"></a>00301         }
<a name="l00302"></a>00302 
<a name="l00303"></a><a class="code" href="classOgre_1_1Vector2.html#181745a04b7b95bffc331fd9a4519931">00303</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator /= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )
<a name="l00304"></a>00304         {
<a name="l00305"></a>00305             x /= rkVector.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a>;
<a name="l00306"></a>00306             y /= rkVector.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00307"></a>00307 
<a name="l00308"></a>00308             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00309"></a>00309         }
<a name="l00310"></a>00310 
<a name="l00318"></a><a class="code" href="classOgre_1_1Vector2.html#37afa7257464098c518321ddf438f1a9">00318</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> length ()<span class="keyword"> const</span>
<a name="l00319"></a>00319 <span class="keyword">        </span>{
<a name="l00320"></a>00320             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#b1ee8b71699ce68bd8cf91113ead793e">Math::Sqrt</a>( x * x + y * y );
<a name="l00321"></a>00321         }
<a name="l00322"></a>00322 
<a name="l00333"></a><a class="code" href="classOgre_1_1Vector2.html#cf2cf937351e108feb474e01d2c982a2">00333</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> squaredLength ()<span class="keyword"> const</span>
<a name="l00334"></a>00334 <span class="keyword">        </span>{
<a name="l00335"></a>00335             <span class="keywordflow">return</span> x * x + y * y;
<a name="l00336"></a>00336         }
<a name="l00337"></a>00337 
<a name="l00352"></a><a class="code" href="classOgre_1_1Vector2.html#864971e600fa97e95a295cb5f2c2f16d">00352</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> dotProduct(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; vec)<span class="keyword"> const</span>
<a name="l00353"></a>00353 <span class="keyword">        </span>{
<a name="l00354"></a>00354             <span class="keywordflow">return</span> x * vec.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a> + y * vec.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00355"></a>00355         }
<a name="l00356"></a>00356 
<a name="l00366"></a><a class="code" href="classOgre_1_1Vector2.html#108e27e1f8c56023377347b661cf067c">00366</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> normalise()
<a name="l00367"></a>00367         {
<a name="l00368"></a>00368             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fLength = <a class="code" href="classOgre_1_1Math.html#b1ee8b71699ce68bd8cf91113ead793e">Math::Sqrt</a>( x * x + y * y);
<a name="l00369"></a>00369 
<a name="l00370"></a>00370             <span class="comment">// Will also work for zero-sized vectors, but will change nothing</span>
<a name="l00371"></a>00371             <span class="keywordflow">if</span> ( fLength &gt; 1e-08 )
<a name="l00372"></a>00372             {
<a name="l00373"></a>00373                 <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fInvLength = 1.0 / fLength;
<a name="l00374"></a>00374                 x *= fInvLength;
<a name="l00375"></a>00375                 y *= fInvLength;
<a name="l00376"></a>00376             }
<a name="l00377"></a>00377 
<a name="l00378"></a>00378             <span class="keywordflow">return</span> fLength;
<a name="l00379"></a>00379         }
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 
<a name="l00386"></a><a class="code" href="classOgre_1_1Vector2.html#d79868b92edb2c5187d8b11387010a7d">00386</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> midPoint( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; vec )<span class="keyword"> const</span>
<a name="l00387"></a>00387 <span class="keyword">        </span>{
<a name="l00388"></a>00388             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00389"></a>00389                 ( x + vec.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a> ) * 0.5,
<a name="l00390"></a>00390                 ( y + vec.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a> ) * 0.5 );
<a name="l00391"></a>00391         }
<a name="l00392"></a>00392 
<a name="l00396"></a><a class="code" href="classOgre_1_1Vector2.html#a756107b53717cfa38efec9e0840f630">00396</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator &lt; ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rhs )<span class="keyword"> const</span>
<a name="l00397"></a>00397 <span class="keyword">        </span>{
<a name="l00398"></a>00398             <span class="keywordflow">if</span>( x &lt; rhs.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a> &amp;&amp; y &lt; rhs.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a> )
<a name="l00399"></a>00399                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00400"></a>00400             <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00401"></a>00401         }
<a name="l00402"></a>00402 
<a name="l00406"></a><a class="code" href="classOgre_1_1Vector2.html#a66f1e244af12ef400f1cc416b408e19">00406</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator &gt; ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rhs )<span class="keyword"> const</span>
<a name="l00407"></a>00407 <span class="keyword">        </span>{
<a name="l00408"></a>00408             <span class="keywordflow">if</span>( x &gt; rhs.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a> &amp;&amp; y &gt; rhs.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a> )
<a name="l00409"></a>00409                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00410"></a>00410             <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00411"></a>00411         }
<a name="l00412"></a>00412 
<a name="l00420"></a><a class="code" href="classOgre_1_1Vector2.html#946495c4a55e1f8048aab6920bf0ac9f">00420</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> makeFloor( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; cmp )
<a name="l00421"></a>00421         {
<a name="l00422"></a>00422             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a> &lt; x ) x = cmp.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a>;
<a name="l00423"></a>00423             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a> &lt; y ) y = cmp.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00424"></a>00424         }
<a name="l00425"></a>00425 
<a name="l00433"></a><a class="code" href="classOgre_1_1Vector2.html#408be4c5539e93a4272e05249bafe0be">00433</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> makeCeil( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; cmp )
<a name="l00434"></a>00434         {
<a name="l00435"></a>00435             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a> &gt; x ) x = cmp.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a>;
<a name="l00436"></a>00436             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a> &gt; y ) y = cmp.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00437"></a>00437         }
<a name="l00438"></a>00438 
<a name="l00446"></a><a class="code" href="classOgre_1_1Vector2.html#ea8cb94f0258c7b8f204588f05d7d0f0">00446</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> perpendicular(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00447"></a>00447 <span class="keyword">        </span>{
<a name="l00448"></a>00448             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> (-y, x);
<a name="l00449"></a>00449         }
<a name="l00453"></a><a class="code" href="classOgre_1_1Vector2.html#9785bfabcea2d2fad738571f5c7c106f">00453</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> crossProduct( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00454"></a>00454 <span class="keyword">        </span>{
<a name="l00455"></a>00455             <span class="keywordflow">return</span> x * rkVector.<a class="code" href="classOgre_1_1Vector2.html#d486a13367b71ce0f4c6782297be9725">y</a> - y * rkVector.<a class="code" href="classOgre_1_1Vector2.html#f3eb55ba6d289477e9aa52b8de341380">x</a>;
<a name="l00456"></a>00456         }
<a name="l00476"></a><a class="code" href="classOgre_1_1Vector2.html#bf1030549182b8fcf19def12e2706e6f">00476</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> randomDeviant(
<a name="l00477"></a>00477             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> angle)<span class="keyword"> const</span>
<a name="l00478"></a>00478 <span class="keyword">        </span>{
<a name="l00479"></a>00479 
<a name="l00480"></a>00480             angle *=  <a class="code" href="classOgre_1_1Math.html#17da3bb870f8654628d6f429a144aea1">Math::UnitRandom</a>() * <a class="code" href="classOgre_1_1Math.html#58d139439316e19e9142000f1a6bdf6d">Math::TWO_PI</a>;
<a name="l00481"></a>00481             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> cosa = cos(angle);
<a name="l00482"></a>00482             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> sina = sin(angle);
<a name="l00483"></a>00483             <span class="keywordflow">return</span>  <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(cosa * x - sina * y,
<a name="l00484"></a>00484                             sina * x + cosa * y);
<a name="l00485"></a>00485         }
<a name="l00486"></a>00486 
<a name="l00488"></a><a class="code" href="classOgre_1_1Vector2.html#1946e867aa921f61de967cf244774531">00488</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> isZeroLength(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00489"></a>00489 <span class="keyword">        </span>{
<a name="l00490"></a>00490             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> sqlen = (x * x) + (y * y);
<a name="l00491"></a>00491             <span class="keywordflow">return</span> (sqlen &lt; (1e-06 * 1e-06));
<a name="l00492"></a>00492 
<a name="l00493"></a>00493         }
<a name="l00494"></a>00494 
<a name="l00497"></a><a class="code" href="classOgre_1_1Vector2.html#735f0406c751af9b3ac79c855301e466">00497</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> normalisedCopy(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00498"></a>00498 <span class="keyword">        </span>{
<a name="l00499"></a>00499             <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> ret = *<span class="keyword">this</span>;
<a name="l00500"></a>00500             ret.<a class="code" href="classOgre_1_1Vector2.html#108e27e1f8c56023377347b661cf067c" title="Normalises the vector.">normalise</a>();
<a name="l00501"></a>00501             <span class="keywordflow">return</span> ret;
<a name="l00502"></a>00502         }
<a name="l00503"></a>00503 
<a name="l00507"></a><a class="code" href="classOgre_1_1Vector2.html#ffe288cd3a7424b7fdb0ae34b2ddf807">00507</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> reflect(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; normal)<span class="keyword"> const</span>
<a name="l00508"></a>00508 <span class="keyword">        </span>{
<a name="l00509"></a>00509             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>( *<span class="keyword">this</span> - ( 2 * this-&gt;dotProduct(normal) * normal ) );
<a name="l00510"></a>00510         }
<a name="l00511"></a>00511 
<a name="l00512"></a>00512         <span class="comment">// special points</span>
<a name="l00513"></a><a class="code" href="classOgre_1_1Vector2.html#70fef72151781ad0174a004a8b6b3acc">00513</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> ZERO;
<a name="l00514"></a><a class="code" href="classOgre_1_1Vector2.html#1c2d210b2756d07375b0cf9f01835496">00514</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> UNIT_X;
<a name="l00515"></a><a class="code" href="classOgre_1_1Vector2.html#d20c8c58c9345a71743416bad82cb5e3">00515</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> UNIT_Y;
<a name="l00516"></a><a class="code" href="classOgre_1_1Vector2.html#52e8d29732eacdeb87d20a3372382590">00516</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> NEGATIVE_UNIT_X;
<a name="l00517"></a><a class="code" href="classOgre_1_1Vector2.html#95486d3e0b884791be22f16d2bb3a4cb">00517</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> NEGATIVE_UNIT_Y;
<a name="l00518"></a><a class="code" href="classOgre_1_1Vector2.html#165a67053e61b0733746453ce9ee5edb">00518</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> UNIT_SCALE;
<a name="l00519"></a>00519 
<a name="l00522"></a>00522         <span class="keyword">inline</span> <a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <span class="keyword">operator</span> &lt;&lt;
<a name="l00523"></a><a class="code" href="classOgre_1_1Vector2.html#f2c1dcbb14e9404733990cdbb2b2d747">00523</a>             ( std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; v )
<a name="l00524"></a>00524         {
<a name="l00525"></a>00525             o &lt;&lt; <span class="stringliteral">"Vector2("</span> &lt;&lt; v.x &lt;&lt; <span class="stringliteral">", "</span> &lt;&lt; v.y &lt;&lt;  <span class="stringliteral">")"</span>;
<a name="l00526"></a>00526             <span class="keywordflow">return</span> o;
<a name="l00527"></a>00527         }
<a name="l00528"></a>00528 
<a name="l00529"></a>00529     };
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 }
<a name="l00532"></a>00532 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:57 2008
</p>
</body>
</html>
